const urlLocation = location.origin;
// const urlLocation = "http://localhost:3939";
const apiUrl = 'dm/vchasno-kasa/api/v1/';
const packdaysContainerNode = document.getElementById('packdays-container');
const packdaysInputNode = document.getElementById('packdays');
const switchPackDaysNode = document.getElementById('switch-pack-days');
const switchAutoUpdateNode = document.getElementById('switch-auto-update');
const autoUpdateTimeInput = document.getElementById('auto-update-time');
const pfIsCustomNode = document.getElementById('pf_is_custom');

const proxyConfigNode = document.getElementsByClassName('proxy-config').item(0);
const switchUseProxy = document.getElementById('switch-use-proxy');
const proxyAddress = document.getElementById('proxy-address');
const proxyPort = document.getElementById('proxy-port');
const proxyLogin = document.getElementById('proxy-login');
const proxyPassword = document.getElementById('proxy-password');
const proxySettings = document.getElementById('proxy-settings');

let printFormB64, user_login, isNeedAuth;

function clearCerts() {
	fetch(`${urlLocation}/${apiUrl}clear_certs`)
		.then(result => {
			if (result.errortxt) {
				callTostSnackbar(result.errortxt);
			} else if (result?.status === 200) {
				callTostSnackbar('Сертифікати очищено');
			} else {
				callTostSnackbar('При очищенні сертифікатів сталася помилка');
			}
		})
		.catch(error => {
			callTostSnackbar(`Request failed: ${error}`);
		})
}

function getData() {
	document.getElementById('pf_del_custom').checked = false;

	fetch(`${urlLocation}/dm/api/v1/sys_info`)
		.then((response) => response.json())
		.then((result) => {

			document.getElementById('dm_version').innerText = result.dm_version;
			document.getElementById('platform').innerText = result.platform;
			document.getElementById('architecture').innerText = result.architecture;
			document.getElementById('platform_name_version').innerText = `${result.platform_name} ${result.platform_version}`;
			document.getElementById('database').innerText = result.database;
			if (result.database === "SQLite") {
				document.getElementById('db_size').style.display = 'flex'; // Show the div
				document.getElementById('dm_db_size').innerText = `${result.dm_db_size} ГБ`;
			}
			document.getElementById('disk_total_space').innerText = `${result.disk_total_space} ГБ`;
			document.getElementById('disk_available_space').innerText = `${result.disk_available_space} ГБ`;
			const platform = result.platform.toLowerCase();

			if (platform === 'windows') {
				proxySettings.classList.remove('hidden');
			}

			fetch(`${urlLocation}/${apiUrl}settings`)
				.then((response) => response.json())
				.then((result) => {
					document.getElementById('logdays').value = result.logdays;
					document.getElementById('archdays').value = result.archdays;
					document.getElementById('extAccess').checked = result.extAccess;
					document.getElementById('supmail').value = result.supmail;
					document.getElementById('pf_charcount').value = result.pf_charcount;
					document.getElementById('pf_charwidth').value = result.pf_charwidth;

					document.getElementById('pf_aspdf').checked = result.pf_aspdf;
					document.getElementById('pf_asimage').checked = result.pf_asimage;
					document.getElementById('pf_astext').checked = result.pf_astext;

					document.getElementById('usr_uiauth').checked = result.usr_uiauth;
					document.getElementById('usr_confpass').value = result.usr_confpass;
					document.getElementById('usr_pass').value = result.usr_pass;
					document.getElementById('usr_login').value = result.usr_login;
					document.getElementById('server_alias').value = result.server_alias;

					user_login = result.usr_login;
					isNeedAuth = result.usr_uiauth;

					document.getElementById('download-print-forms').href = `${urlLocation}/${apiUrl}settings/printforms`;

					if (result.usr_uiauth === true) {
						document.getElementById('usr_pass').placeholder = 'пароль приховано, якщо загубили - придумайте новий';
						document.getElementById('usr_confpass').placeholder = 'пароль приховано, якщо загубили - придумайте новий';
						document.getElementById('x_api_key').placeholder = 'ключ приховано, якщо загубили - придумайте новий';
					}

					if (result.packdays) {
						switchPackDaysNode.checked = true;
						packdaysContainerNode.querySelector('p').classList.add('hidden');
						packdaysContainerNode.querySelector('div').classList.remove('hidden');
						packdaysInputNode.value = result.packdays;
					} else {
						switchPackDaysNode.checked = false;
						packdaysContainerNode.querySelector('p').classList.remove('hidden');
						packdaysContainerNode.querySelector('div').classList.add('hidden');
						packdaysInputNode.value = 0;
					}
					if (result.pf_is_custom) {
						pfIsCustomNode.innerHTML = 'Користувацькі друковані форми <b>завантажено</b>';
						document.getElementById('delete_print_forms').classList.remove('hidden');
						document.getElementById('download-print-forms').classList.remove('hidden');
					} else {
						pfIsCustomNode.innerHTML = 'Користувацькі друковані форми не завантажено';
						document.getElementById('delete_print_forms').classList.add('hidden');
						document.getElementById('download-print-forms').classList.add('hidden');
					}

					switchAutoUpdateNode.checked = result.autoupdate;
					autoUpdateTimeInput.value = result.autoupdatetime;

					switchUseProxy.checked = result.proxy_use;
					proxyAddress.value = result.proxy_ip;
					proxyPort.value = result.proxy_port ? Number(result.proxy_port) : '';
					proxyLogin.value = result.proxy_login;

					if (result.proxy_use) {
						proxyConfigNode.classList.remove('hidden');
					} else {
						proxyConfigNode.classList.add('hidden');
					}
				});
		})
}
getData();
function submitData() {
	const logdays = document.getElementById('logdays').value;
	const archdays = document.getElementById('archdays').value;
	const extAccess = document.getElementById('extAccess').value;
	const supmail = document.getElementById('supmail').value;

	const pf_charcount = document.getElementById('pf_charcount').value;
	const pf_charwidth = document.getElementById('pf_charwidth').value;

	const pf_aspdf = document.getElementById('pf_aspdf').checked;
	const pf_asimage = document.getElementById('pf_asimage').checked;
	const pf_astext = document.getElementById('pf_astext').checked;
	const pf_del_custom = document.getElementById('pf_del_custom').checked;

	const usr_uiauth = document.getElementById('usr_uiauth').checked;
	const usr_confpass = document.getElementById('usr_confpass').value;
	const usr_pass = document.getElementById('usr_pass').value;
	const usr_login = document.getElementById('usr_login').value;
	const x_api_key = document.getElementById('x_api_key').value;
	const server_alias = document.getElementById('server_alias').value;
	const autoupdate = switchAutoUpdateNode.checked;
	const autoupdatetime = autoUpdateTimeInput.value;
	const usr_chuser = Boolean((user_login != usr_login) || isNeedAuth != usr_uiauth || usr_pass);

	const proxy_use = switchUseProxy.checked;
	const proxy_ip = proxyAddress.value;
	const proxy_port = proxyPort.value;
	const proxy_login = proxyLogin.value;
	const proxy_pass = proxyPassword.value;

	const data = {
		logdays: logdays,
		archdays: archdays,
		extAccess: extAccess,
		supmail: supmail,
		packdays: packdaysInputNode.value,
		pf_aspdf,
		pf_asimage,
		pf_astext,
		pf_del_custom,
		pf_charcount,
		pf_charwidth,
		pf_custom: printFormB64,
		usr_uiauth,
		usr_chuser,
		usr_confpass,
		usr_pass,
		usr_login,
		x_api_key,
		server_alias,
		autoupdate,
		autoupdatetime,

		proxy_use,
		proxy_ip: proxy_use ? proxy_ip : '',
		proxy_port: proxy_use ? proxy_port : '',
		proxy_login: proxy_use ? proxy_login : '',
		proxy_pass: proxy_use ? proxy_pass : '',
	};

	const json = JSON.stringify(data);

	fetch(`${urlLocation}/${apiUrl}settings`, {
		method: 'POST',
		body: json,
	})
		.then((response) => response.json())
		.then((result) => {
			if (result.errortxt) {
				callTostSnackbar(result.errortxt);
			} else {
				document.getElementById('loaded-file').classList.add('hidden');
				callTostSnackbar('Дані збережено');
				if (!usr_uiauth && usr_uiauth != isNeedAuth) {
					document.querySelector('.button-hover.logout-button') && document.querySelector('.button-hover.logout-button').classList.add('hidden');
					delete_cookie('DMUIToken');
				}
				getData();
			}
		});
}
function getPrintForms() {
	fetch(`${urlLocation}/${apiUrl}settings/printforms`)
		.then((response) => response.json())
		.then((result) => {
			var url = window.URL.createObjectURL(blob);
			var a = document.createElement('a');
			a.href = url;
			a.download = "filename.xlsx";
			document.body.appendChild(a);
			if (result.errortxt) {
				callTostSnackbar(result.errortxt);
			} else {
				callTostSnackbar('Файл завантажено');
				getData();
			}
		});
}
function addFilePrintForms(fileInput) {
	let file = fileInput.files[0],
		reader = new FileReader();
	reader.readAsDataURL(file);
	reader.onloadend = function () {
		printFormB64 = reader.result.split('base64,')[1];
		document.getElementById('loaded-file').classList.remove('hidden');
		document.getElementById('loaded-file').querySelector('span').innerHTML = file.name;
	};
}

function validate(checkboxNode) {
	if (checkboxNode.checked) {
		checkboxNode.value = true;
		checkboxNode.checked = true;
	} else {
		checkboxNode.value = false;
		checkboxNode.checked = false;
	}
}
function switchPackDays(checkboxNode) {
	if (checkboxNode.checked) {
		checkboxNode.checked = true;
		packdaysContainerNode.querySelector('p').classList.add('hidden');
		packdaysContainerNode.querySelector('div').classList.remove('hidden');
		packdaysInputNode.value = 40;
	} else {
		checkboxNode.checked = false;
		packdaysContainerNode.querySelector('p').classList.remove('hidden');
		packdaysContainerNode.querySelector('div').classList.add('hidden');
		packdaysInputNode.value = 0;
	}
}
function switchUseProxyFlag(checkboxNode) {
	if (checkboxNode.checked) {
		proxyConfigNode.classList.remove('hidden');
	} else {
		proxyConfigNode.classList.add('hidden');
	}
}
function goBack() {
	window.history.back();
}
document.getElementById('packdays').addEventListener('blur', (e) => {
	if (Number(e.target.value) < 40) {
		packdaysInputNode.value = 40;

	}
});
